#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int main(){
    ll A, B;
    cin >> A >> B;
    ll niza[A];
    for(ll i=0; i<A; i++){
        cin >> niza[i];
    }if(niza[0]==0 && niza[1]==0 ){
            if(B>=2){
                    bool two=false;
                    bool one=false, oone = false;
                    for(int i=0; i<A; i++){
                        if(niza[i]==2 && !two){
                            two=true;
                        }
                        if(niza[i]==2 && two){
                            cout << 2;
                            return 0;
                        }
                        if(niza[i]==1 && !one) one=true;
                        if(niza[i]==1 && one) oone=true;
                    }
                    if(oone==true){
                        cout << 1;
                        return 0;
                    }
                    else{
                        cout << 0;
                        return 0;
                    }
            }
            else{
                    bool one=false;
                for(int i=0; i<A; i++){
                    if(niza[i]==2){
                        cout << 2;
                        return 0;
                    }
                    if(niza[i]==1) one=true;
                }
                if(!one){
                    cout << 0;
                    return 0;
                }
                else{
                    cout << 1;
                }
            }
}
else{
    cout << 0;
}


}
